## Copyright (C) 2015 Stéphane Canu
## 
## This program is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

## -*- texinfo -*- 
## @deftypefn {Function File} {@var{retval} =} kernel (@var{input1}, @var{input2})
##
## @seealso{}
## @end deftypefn

## Author: Stéphane Canu <stephane@MacBook-Pro-de-Stephane-Canu-2.local>
## Created: 2015-06-03

function [Kt] = kernel (Xt, Xapp, kerneloption)

     metric = diag(1./kerneloption.^2);
     ps = Xt*metric*Xapp';
     [nps,pps]=size(ps);
     normx = sum(Xt.^2*metric,2);
     normxsup = sum(Xapp.^2*metric,2);
     ps = -2*ps + repmat(normx,1,pps) + repmat(normxsup',nps,1) ;
     Kt = exp(-ps/2);

 endfunction
