%%
clear
close all
rand('seed',1);
randn('seed',1);

%% Data
% training data

load TP_data

%%

figure(1); 
set(gcf,'Color',[1,1,1])
plot(Xapp(yapp==1,1),Xapp(yapp==1,2),'+r'); hold on
plot(Xapp(yapp==0,1),Xapp(yapp==0,2),'xb'); 

%% Reg log initialization
N = 200;                               % number maximum of iterations
loglik_old = 1/eps;                % 
X = [Xapp ones(n,1)];
[n,q] = size(X);
w = zeros(q,1);
i = 0;
loglik  = loglik_old-1;
lambda = 0*sqrt(eps);
I = eye(q);

%% Reg log main loop

while  and((i<N)  , (loglik_old - loglik > eps^(1/4)))
    
    wold = w;
    
    p = 1./(1+exp(-X*w));                               % calcul des probabilits  
    W = (p.*(1-p)+sqrt(eps));                           % calcul de la matrice Hessienne 
    z = W.*(X*w)  + (yapp-p);                          % calcul de la variable intermdiaire
    w = (X'*diag(W)*X + lambda*I)\(X'*z);         % regression sur z
    
    err = sum(X*w.*(2*yapp-1)<0);                  % calcul du nombre d'erreur
    i = i+1;                                                    % calcul du nombre d'itrations
    loglik_old = loglik;
    loglik = sum(-yapp.*(X*w) + log(1 + exp(X*w)));
    loglik = sum(log(1+exp(-zapp.*(X*w))));

    b = w(q);
    w(q) = [];

x1 = -3;
y1 = (-b-(w(1)*x1))/w(2);
x2 = 5;
y2 = (-b-(w(1)*x2))/w(2);
plot([x1 x2],[y1 y2],'m','LineWidth',.5)
axis([-3 5 -2  3])

w(q) = b;

endwhile

w = wold;

%%
% drawing the lines
b = w(q);

x1 = -3;
y1 = (-b-(w(1)*x1))/w(2);
x2 = 5;
y2 = (-b-(w(1)*x2))/w(2);
plot([x1 x2],[y1 y2],'g','LineWidth',2)




