%%
clear
close all
rand('seed',1);
randn('seed',1);

%% Data
% training data

load TP_data

%%

figure(1); 
set(gcf,'Color',[1,1,1])
plot(Xapp(yapp==1,1),Xapp(yapp==1,2),'+r'); hold on
plot(Xapp(yapp==0,1),Xapp(yapp==0,2),'xb'); 

%% Kernelization

kerneloption = .5;
[Kapp] = kernel (Xapp, Xapp, kerneloption);


%% Reg log initialization

[n,q] = size(Kapp);
X = [Kapp ones(n,1)];
N = 200;
lambda = 1;
w = my_reglog(X,yapp,N, lambda);


Ik = eye(q);
I = eye(q+1);
ak = [Kapp+5*lambda*Ik ones(n,1); ones(1,n) 0]\[yapp;0];
a = (X'*X + lambda*I)\(X'*yapp);

%% error probabilits


[Kt] = kernel (Xt, Xapp, kerneloption);
Xt = [Kt ones(nt,1)];
ypred = (1./(1+exp(-Xt*w)));

ind1 = find(ypred > 0.5);
probT = 1-prob;
probT(ind1) = prob(ind1);
perrRL = sum(marg.*probT);


ypred2 = Xt*a;
ind1 = find(ypred2 > 0.5);
probT = 1-prob;
probT(ind1) = prob(ind1);
perrL2 = sum(marg.*probT);

ypred2 = Xt*ak;
ind1 = find(ypred2 > 0.5);
probT = 1-prob;
probT(ind1) = prob(ind1);
perrK = sum(marg.*probT);


bayes_error = sum(marg.*(prob.*(prob<0.5)+(1-prob).*(prob>=.5)));

fprintf('Bayes: %5.2f%% RegLog: %5.2f%% K L2: %5.2f%%  RKHS: %5.2f%% \n',100*[bayes_error perrRL perrL2 perrK])


%% do the nice plot

[xtest1 xtest2]  = meshgrid([-1:.05:1.2]*3.5+.5,[-1:0.05:1]*3); 
[nn mm] = size(xtest1); 
Xtest = [reshape(xtest1 ,nn*mm,1) reshape(xtest2 ,nn*mm,1)]; 

nt = length(Xtest);
[Kt] = kernel (Xtest, Xapp, kerneloption);
Xt = [Kt ones(nt,1)];
ypred = (1./(1+exp(-Xt*w)));

ind1 = find(ypred > 0.5);
probT = 1-prob;
probT(ind1) = prob(ind1);
perr = sum(marg.*probT);

ypred = reshape(ypred,nn,mm); 

figure(1); 
contourf(xtest1,xtest2,(ypred),15,'LineWidth',.5);shading flat;hold on; 
plot(Xapp(yapp==1,1),Xapp(yapp==1,2),'+r'); hold on
plot(Xapp(yapp==0,1),Xapp(yapp==0,2),'xb'); 
[cc, hh]=contour(xtest1,xtest2,ypred,[-100000 0.5],'w','LineWidth',4); 
clabel(cc,hh); 
axis([-3. 4 -3 3])


