## Copyright (C) 2015 Stéphane Canu
## 
## This program is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see <http://www.gnu.org/licenses/>.

## -*- texinfo -*- 
## @deftypefn {Function File} {@var{retval} =} my_reglog_l1 (@var{input1}, @var{input2})
##
## @seealso{}
## @end deftypefn

## Author: Stéphane Canu <stephane@mbpdestanecanu2>
## Created: 2015-06-03

function [w] = my_reglog_l1 (X, yapp, pas, lambda, N)


loglik_old = 1/eps;                % 
[n,q] = size(X);
w = zeros(q,1);
i = 0;
loglik  = loglik_old-1;
I = eye(q);

%% Reg log main loop

while  and((i<N)  , (loglik_old - loglik > eps^(1/4)))
    
    wold = w;
    
    p = 1./(1+exp(-X*w));                       % calcul des probabilits  
    g = X'*(p - yapp);                          % calcul du gradient
    w = w - pas * g;         % 
    w = sign(w).*max(0,abs(w) - pas*lambda);    % operateur proximal

    
    err = sum(X*w.*(2*yapp-1)<0);                  % calcul du nombre d'erreur
    i = i+1;                                                    % calcul du nombre d'itrations
    loglik_old = loglik;
    loglik = sum(-yapp.*(X*w) + log(1 + exp(X*w))) + lambda*sum(abs(w));


end

w = wold;

endfunction
